/*----- PROTECTED REGION ID(A2720.h) ENABLED START -----*/
//=============================================================================
//
// file :        A2720.h
//
// description : Include file for the A2720 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2018-02-19 16:52:13 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef A2720_H
#define A2720_H

#include <tango.h>
#include <Socket2Client.h>

/*----- PROTECTED REGION END -----*/	//	A2720.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  A2720 class description:
 *    
 */


namespace A2720_ns
{
/*----- PROTECTED REGION ID(A2720::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
#if 0
class A2720Worker;
#endif

/*----- PROTECTED REGION END -----*/	//	A2720::Additional Class Declarations

class A2720 : public Socket2Client_ns::Socket2Client
{

/*----- PROTECTED REGION ID(A2720::Data Members) ENABLED START -----*/

//	Add your own data members
	string init_error;
	int iostatus;

#if 0
	A2720Worker *worker;
public:
	volatile bool cont;
#endif

/*----- PROTECTED REGION END -----*/	//	A2720::Data Members

//	Device property data members
public:
	//	CycEndCurr:	
	Tango::DevDouble	cycEndCurr;
	//	CycMaxCurr:	
	Tango::DevDouble	cycMaxCurr;
	//	CycMinCurr:	
	Tango::DevDouble	cycMinCurr;
	//	CycNumTimes:	
	Tango::DevULong	cycNumTimes;
	//	CycRampSlopeCurr:	
	Tango::DevDouble	cycRampSlopeCurr;
	//	CycWaitTime:	
	Tango::DevULong	cycWaitTime;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevFloat	*attr_ADCTempCoefficient0_read;
	Tango::DevFloat	*attr_ADCTempCoefficient1_read;
	Tango::DevFloat	*attr_ADCTemperature_read;
	Tango::DevFloat	*attr_AuxVoltageCoefficient0_read;
	Tango::DevFloat	*attr_AuxVoltageCoefficient1_read;
	Tango::DevDouble	*attr_AuxiliaryVoltage_read;
	Tango::DevString	*attr_CalibrationDate_read;
	Tango::DevDouble	*attr_Current_read;
	Tango::DevFloat	*attr_CurrentCoefficient0_read;
	Tango::DevFloat	*attr_CurrentCoefficient1_read;
	Tango::DevFloat	*attr_CurrentCoefficient2_read;
	Tango::DevFloat	*attr_CurrentCoefficient3_read;
	Tango::DevFloat	*attr_CurrentCoefficient4_read;
	Tango::DevFloat	*attr_CurrentCoefficient5_read;
	Tango::DevFloat	*attr_CurrentMax_read;
	Tango::DevFloat	*attr_CurrentMin_read;
	Tango::DevDouble	*attr_CurrentSet_read;
	Tango::DevFloat	*attr_DCCurrentCoefficient0_read;
	Tango::DevFloat	*attr_DCCurrentCoefficient1_read;
	Tango::DevDouble	*attr_DCLinkVoltage_read;
	Tango::DevFloat	*attr_HeatsinkTempCoefficient0_read;
	Tango::DevFloat	*attr_HeatsinkTempCoefficient1_read;
	Tango::DevFloat	*attr_HeatsinkTemperature_read;
	Tango::DevFloat	*attr_KDCoefficient_read;
	Tango::DevFloat	*attr_KFFCoefficient_read;
	Tango::DevFloat	*attr_KICoefficient_read;
	Tango::DevFloat	*attr_KPCoefficient_read;
	Tango::DevString	*attr_Model_read;
	Tango::DevFloat	*attr_PulseDuration_read;
	Tango::DevString	*attr_SerialNumber_read;
	Tango::DevFloat	*attr_SlewRate_read;
	Tango::DevDouble	*attr_Voltage_read;
	Tango::DevFloat	*attr_VoltageCoefficient0_read;
	Tango::DevFloat	*attr_VoltageCoefficient1_read;
	Tango::DevBoolean	*attr_PsStat_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	A2720(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	A2720(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	A2720(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~A2720();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : A2720::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : A2720::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute ADCTempCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_ADCTempCoefficient0(Tango::Attribute &attr);
	virtual void write_ADCTempCoefficient0(Tango::WAttribute &attr);
	virtual bool is_ADCTempCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute ADCTempCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_ADCTempCoefficient1(Tango::Attribute &attr);
	virtual void write_ADCTempCoefficient1(Tango::WAttribute &attr);
	virtual bool is_ADCTempCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute ADCTemperature related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_ADCTemperature(Tango::Attribute &attr);
	virtual bool is_ADCTemperature_allowed(Tango::AttReqType type);
/**
 *	Attribute AuxVoltageCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_AuxVoltageCoefficient0(Tango::Attribute &attr);
	virtual void write_AuxVoltageCoefficient0(Tango::WAttribute &attr);
	virtual bool is_AuxVoltageCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute AuxVoltageCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_AuxVoltageCoefficient1(Tango::Attribute &attr);
	virtual void write_AuxVoltageCoefficient1(Tango::WAttribute &attr);
	virtual bool is_AuxVoltageCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute AuxiliaryVoltage related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AuxiliaryVoltage(Tango::Attribute &attr);
	virtual bool is_AuxiliaryVoltage_allowed(Tango::AttReqType type);
/**
 *	Attribute CalibrationDate related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_CalibrationDate(Tango::Attribute &attr);
	virtual bool is_CalibrationDate_allowed(Tango::AttReqType type);
/**
 *	Attribute Current related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Current(Tango::Attribute &attr);
	virtual void write_Current(Tango::WAttribute &attr);
	virtual bool is_Current_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient0(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient0(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient1(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient1(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient2 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient2(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient2(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient2_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient3 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient3(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient3(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient3_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient4 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient4(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient4(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient4_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentCoefficient5 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentCoefficient5(Tango::Attribute &attr);
	virtual void write_CurrentCoefficient5(Tango::WAttribute &attr);
	virtual bool is_CurrentCoefficient5_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentMax related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentMax(Tango::Attribute &attr);
	virtual void write_CurrentMax(Tango::WAttribute &attr);
	virtual bool is_CurrentMax_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentMin related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_CurrentMin(Tango::Attribute &attr);
	virtual void write_CurrentMin(Tango::WAttribute &attr);
	virtual bool is_CurrentMin_allowed(Tango::AttReqType type);
/**
 *	Attribute CurrentSet related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_CurrentSet(Tango::Attribute &attr);
	virtual bool is_CurrentSet_allowed(Tango::AttReqType type);
/**
 *	Attribute DCCurrentCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_DCCurrentCoefficient0(Tango::Attribute &attr);
	virtual void write_DCCurrentCoefficient0(Tango::WAttribute &attr);
	virtual bool is_DCCurrentCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute DCCurrentCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_DCCurrentCoefficient1(Tango::Attribute &attr);
	virtual void write_DCCurrentCoefficient1(Tango::WAttribute &attr);
	virtual bool is_DCCurrentCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute DCLinkVoltage related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DCLinkVoltage(Tango::Attribute &attr);
	virtual bool is_DCLinkVoltage_allowed(Tango::AttReqType type);
/**
 *	Attribute DCurr related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void write_DCurr(Tango::WAttribute &attr);
	virtual bool is_DCurr_allowed(Tango::AttReqType type);
/**
 *	Attribute HeatsinkTempCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_HeatsinkTempCoefficient0(Tango::Attribute &attr);
	virtual void write_HeatsinkTempCoefficient0(Tango::WAttribute &attr);
	virtual bool is_HeatsinkTempCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute HeatsinkTempCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_HeatsinkTempCoefficient1(Tango::Attribute &attr);
	virtual void write_HeatsinkTempCoefficient1(Tango::WAttribute &attr);
	virtual bool is_HeatsinkTempCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute HeatsinkTemperature related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_HeatsinkTemperature(Tango::Attribute &attr);
	virtual bool is_HeatsinkTemperature_allowed(Tango::AttReqType type);
/**
 *	Attribute KDCoefficient related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_KDCoefficient(Tango::Attribute &attr);
	virtual void write_KDCoefficient(Tango::WAttribute &attr);
	virtual bool is_KDCoefficient_allowed(Tango::AttReqType type);
/**
 *	Attribute KFFCoefficient related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_KFFCoefficient(Tango::Attribute &attr);
	virtual void write_KFFCoefficient(Tango::WAttribute &attr);
	virtual bool is_KFFCoefficient_allowed(Tango::AttReqType type);
/**
 *	Attribute KICoefficient related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_KICoefficient(Tango::Attribute &attr);
	virtual void write_KICoefficient(Tango::WAttribute &attr);
	virtual bool is_KICoefficient_allowed(Tango::AttReqType type);
/**
 *	Attribute KPCoefficient related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_KPCoefficient(Tango::Attribute &attr);
	virtual void write_KPCoefficient(Tango::WAttribute &attr);
	virtual bool is_KPCoefficient_allowed(Tango::AttReqType type);
/**
 *	Attribute Model related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Model(Tango::Attribute &attr);
	virtual bool is_Model_allowed(Tango::AttReqType type);
/**
 *	Attribute PulseDuration related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_PulseDuration(Tango::Attribute &attr);
	virtual void write_PulseDuration(Tango::WAttribute &attr);
	virtual bool is_PulseDuration_allowed(Tango::AttReqType type);
/**
 *	Attribute SerialNumber related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_SerialNumber(Tango::Attribute &attr);
	virtual bool is_SerialNumber_allowed(Tango::AttReqType type);
/**
 *	Attribute SlewRate related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_SlewRate(Tango::Attribute &attr);
	virtual void write_SlewRate(Tango::WAttribute &attr);
	virtual bool is_SlewRate_allowed(Tango::AttReqType type);
/**
 *	Attribute Voltage related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Voltage(Tango::Attribute &attr);
	virtual bool is_Voltage_allowed(Tango::AttReqType type);
/**
 *	Attribute VoltageCoefficient0 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_VoltageCoefficient0(Tango::Attribute &attr);
	virtual void write_VoltageCoefficient0(Tango::WAttribute &attr);
	virtual bool is_VoltageCoefficient0_allowed(Tango::AttReqType type);
/**
 *	Attribute VoltageCoefficient1 related methods
 *
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_VoltageCoefficient1(Tango::Attribute &attr);
	virtual void write_VoltageCoefficient1(Tango::WAttribute &attr);
	virtual bool is_VoltageCoefficient1_allowed(Tango::AttReqType type);
/**
 *	Attribute PsStat related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Spectrum max = 10
 */
	virtual void read_PsStat(Tango::Attribute &attr);
	virtual bool is_PsStat_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : A2720::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Abort related method
	 *
	 *
	 */
	virtual void abort();
	virtual bool is_Abort_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command On related method
	 *
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command StartCycling related method
	 *
	 *
	 */
	virtual void start_cycling();
	virtual bool is_StartCycling_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : A2720::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(A2720::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();
	string send_command(const string&);
	void check_state();
#if 0
	bool is_on_target();
#endif

/*----- PROTECTED REGION END -----*/	//	A2720::Additional Method prototypes
};

/*----- PROTECTED REGION ID(A2720::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions
#if 0
class A2720Worker : public omni_thread, public Tango::LogAdapter
{
	A2720 *device;
	void run(void*);

	public:
	A2720Worker(A2720 *device_) :
		LogAdapter((Tango::DeviceImpl*)device_),
		device(device_) {
			device->cont = true;
		}
};
#endif

/*----- PROTECTED REGION END -----*/	//	A2720::Additional Classes Definitions

}	//	End of namespace

#endif   //	A2720_H
