/*----- PROTECTED REGION ID(A2720Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: A2720Class.cpp,v 1.4 2018-02-19 16:52:13 alessio Exp $";
static const char *TagName    = "A2720 $Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/a2720/src/A2720Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        A2720Class.cpp
//
// description : C++ source for the A2720Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the A2720 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2018-02-19 16:52:13 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <A2720Class.h>

/*----- PROTECTED REGION END -----*/	//	A2720Class.cpp

//-------------------------------------------------------------------
/**
 *	Create A2720Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_A2720_class(const char *name) {
		return A2720_ns::A2720Class::init(name);
	}
}

namespace A2720_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
A2720Class *A2720Class::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
const long PsStatAttrib::X_DATA_SIZE;
//--------------------------------------------------------
/**
 * method : 		A2720Class::A2720Class(std::string &s)
 * description : 	constructor for the A2720Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
A2720Class::A2720Class(std::string &s):Socket2Client_ns::Socket2ClientClass(s)
{
	TANGO_LOG_INFO << "Entering A2720Class constructor" << std::endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(A2720Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::constructor

	TANGO_LOG_INFO << "Leaving A2720Class constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		A2720Class::~A2720Class()
 * description : 	destructor for the A2720Class
 */
//--------------------------------------------------------
A2720Class::~A2720Class()
{
	/*----- PROTECTED REGION ID(A2720Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		A2720Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
A2720Class *A2720Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new A2720Class(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		A2720Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
A2720Class *A2720Class::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AbortClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "AbortClass::execute(): arrived" << std::endl;
	((static_cast<A2720 *>(device))->abort());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "OffClass::execute(): arrived" << std::endl;
	((static_cast<A2720 *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "OnClass::execute(): arrived" << std::endl;
	((static_cast<A2720 *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetClass::execute(): arrived" << std::endl;
	((static_cast<A2720 *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StartCyclingClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartCyclingClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "StartCyclingClass::execute(): arrived" << std::endl;
	((static_cast<A2720 *>(device))->start_cycling());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : A2720Class::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum A2720Class::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum A2720Class::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum A2720Class::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::get_class_property()
 *	Description: Read database to initialize class property data members.
 */
//--------------------------------------------------------
void A2720Class::get_class_property()
{
	/*----- PROTECTED REGION ID(A2720Class::get_class_property_before) ENABLED START -----*/
	
	//	Initialize class property data members
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("CycEndCurr"));
	cl_prop.push_back(Tango::DbDatum("CycMaxCurr"));
	cl_prop.push_back(Tango::DbDatum("CycMinCurr"));
	cl_prop.push_back(Tango::DbDatum("CycNumTimes"));
	cl_prop.push_back(Tango::DbDatum("CycRampSlopeCurr"));
	cl_prop.push_back(Tango::DbDatum("CycStartCurr"));
	cl_prop.push_back(Tango::DbDatum("CycWaitTime"));

	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract CycEndCurr value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycEndCurr;
	else
	{
		//	Check default value for CycEndCurr
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycEndCurr;
			cl_prop[i]  <<  cycEndCurr;
		}
	}
	//	Try to extract CycMaxCurr value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycMaxCurr;
	else
	{
		//	Check default value for CycMaxCurr
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycMaxCurr;
			cl_prop[i]  <<  cycMaxCurr;
		}
	}
	//	Try to extract CycMinCurr value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycMinCurr;
	else
	{
		//	Check default value for CycMinCurr
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycMinCurr;
			cl_prop[i]  <<  cycMinCurr;
		}
	}
	//	Try to extract CycNumTimes value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycNumTimes;
	else
	{
		//	Check default value for CycNumTimes
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycNumTimes;
			cl_prop[i]  <<  cycNumTimes;
		}
	}
	//	Try to extract CycRampSlopeCurr value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycRampSlopeCurr;
	else
	{
		//	Check default value for CycRampSlopeCurr
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycRampSlopeCurr;
			cl_prop[i]  <<  cycRampSlopeCurr;
		}
	}
	//	Try to extract CycStartCurr value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycStartCurr;
	else
	{
		//	Check default value for CycStartCurr
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycStartCurr;
			cl_prop[i]  <<  cycStartCurr;
		}
	}
	//	Try to extract CycWaitTime value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  cycWaitTime;
	else
	{
		//	Check default value for CycWaitTime
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  cycWaitTime;
			cl_prop[i]  <<  cycWaitTime;
		}
	}
	/*----- PROTECTED REGION ID(A2720Class::get_class_property_after) ENABLED START -----*/
	
	//	Check class property data members init
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void A2720Class::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties
	prop_name = "CycEndCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycMaxCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycMinCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycNumTimes";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycRampSlopeCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycStartCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "CycWaitTime";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "CycEndCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CycMaxCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CycMinCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CycNumTimes";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CycRampSlopeCurr";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CycWaitTime";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void A2720Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : A2720Class::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void A2720Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(A2720Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new A2720(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		A2720 *dev = static_cast<A2720 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(A2720Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : A2720Class::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void A2720Class::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(A2720Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::attribute_factory_before
	//	Call atribute_factory for inherited class
	Socket2Client_ns::Socket2ClientClass::attribute_factory(att_list);

	//	Attribute : ADCTempCoefficient0
	ADCTempCoefficient0Attrib	*adctempcoefficient0 = new ADCTempCoefficient0Attrib();
	Tango::UserDefaultAttrProp	adctempcoefficient0_prop;
	//	description	not set for ADCTempCoefficient0
	adctempcoefficient0_prop.set_label("ADC temperature coefficient 0");
	//	unit	not set for ADCTempCoefficient0
	//	standard_unit	not set for ADCTempCoefficient0
	//	display_unit	not set for ADCTempCoefficient0
	adctempcoefficient0_prop.set_format("%6.5f");
	//	max_value	not set for ADCTempCoefficient0
	//	min_value	not set for ADCTempCoefficient0
	//	max_alarm	not set for ADCTempCoefficient0
	//	min_alarm	not set for ADCTempCoefficient0
	//	max_warning	not set for ADCTempCoefficient0
	//	min_warning	not set for ADCTempCoefficient0
	//	delta_t	not set for ADCTempCoefficient0
	//	delta_val	not set for ADCTempCoefficient0
	adctempcoefficient0->set_default_properties(adctempcoefficient0_prop);
	//	Not Polled
	adctempcoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(adctempcoefficient0);

	//	Attribute : ADCTempCoefficient1
	ADCTempCoefficient1Attrib	*adctempcoefficient1 = new ADCTempCoefficient1Attrib();
	Tango::UserDefaultAttrProp	adctempcoefficient1_prop;
	//	description	not set for ADCTempCoefficient1
	adctempcoefficient1_prop.set_label("ADC temperature coefficient 1");
	//	unit	not set for ADCTempCoefficient1
	//	standard_unit	not set for ADCTempCoefficient1
	//	display_unit	not set for ADCTempCoefficient1
	adctempcoefficient1_prop.set_format("%6.5f");
	//	max_value	not set for ADCTempCoefficient1
	//	min_value	not set for ADCTempCoefficient1
	//	max_alarm	not set for ADCTempCoefficient1
	//	min_alarm	not set for ADCTempCoefficient1
	//	max_warning	not set for ADCTempCoefficient1
	//	min_warning	not set for ADCTempCoefficient1
	//	delta_t	not set for ADCTempCoefficient1
	//	delta_val	not set for ADCTempCoefficient1
	adctempcoefficient1->set_default_properties(adctempcoefficient1_prop);
	//	Not Polled
	adctempcoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(adctempcoefficient1);

	//	Attribute : ADCTemperature
	ADCTemperatureAttrib	*adctemperature = new ADCTemperatureAttrib();
	Tango::UserDefaultAttrProp	adctemperature_prop;
	//	description	not set for ADCTemperature
	adctemperature_prop.set_label("ADC temperature");
	adctemperature_prop.set_unit("C");
	adctemperature_prop.set_standard_unit("1.0");
	adctemperature_prop.set_display_unit("C");
	adctemperature_prop.set_format("%2.1f");
	//	max_value	not set for ADCTemperature
	//	min_value	not set for ADCTemperature
	//	max_alarm	not set for ADCTemperature
	//	min_alarm	not set for ADCTemperature
	//	max_warning	not set for ADCTemperature
	//	min_warning	not set for ADCTemperature
	//	delta_t	not set for ADCTemperature
	//	delta_val	not set for ADCTemperature
	adctemperature->set_default_properties(adctemperature_prop);
	//	Not Polled
	adctemperature->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(adctemperature);

	//	Attribute : AuxVoltageCoefficient0
	AuxVoltageCoefficient0Attrib	*auxvoltagecoefficient0 = new AuxVoltageCoefficient0Attrib();
	Tango::UserDefaultAttrProp	auxvoltagecoefficient0_prop;
	//	description	not set for AuxVoltageCoefficient0
	auxvoltagecoefficient0_prop.set_label("Auxiliary voltage coefficient 0");
	//	unit	not set for AuxVoltageCoefficient0
	//	standard_unit	not set for AuxVoltageCoefficient0
	//	display_unit	not set for AuxVoltageCoefficient0
	auxvoltagecoefficient0_prop.set_format("%6.6f");
	//	max_value	not set for AuxVoltageCoefficient0
	//	min_value	not set for AuxVoltageCoefficient0
	//	max_alarm	not set for AuxVoltageCoefficient0
	//	min_alarm	not set for AuxVoltageCoefficient0
	//	max_warning	not set for AuxVoltageCoefficient0
	//	min_warning	not set for AuxVoltageCoefficient0
	//	delta_t	not set for AuxVoltageCoefficient0
	//	delta_val	not set for AuxVoltageCoefficient0
	auxvoltagecoefficient0->set_default_properties(auxvoltagecoefficient0_prop);
	//	Not Polled
	auxvoltagecoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(auxvoltagecoefficient0);

	//	Attribute : AuxVoltageCoefficient1
	AuxVoltageCoefficient1Attrib	*auxvoltagecoefficient1 = new AuxVoltageCoefficient1Attrib();
	Tango::UserDefaultAttrProp	auxvoltagecoefficient1_prop;
	//	description	not set for AuxVoltageCoefficient1
	auxvoltagecoefficient1_prop.set_label("Auxiliary voltage coefficient 1");
	//	unit	not set for AuxVoltageCoefficient1
	//	standard_unit	not set for AuxVoltageCoefficient1
	//	display_unit	not set for AuxVoltageCoefficient1
	auxvoltagecoefficient1_prop.set_format("%6.6f");
	//	max_value	not set for AuxVoltageCoefficient1
	//	min_value	not set for AuxVoltageCoefficient1
	//	max_alarm	not set for AuxVoltageCoefficient1
	//	min_alarm	not set for AuxVoltageCoefficient1
	//	max_warning	not set for AuxVoltageCoefficient1
	//	min_warning	not set for AuxVoltageCoefficient1
	//	delta_t	not set for AuxVoltageCoefficient1
	//	delta_val	not set for AuxVoltageCoefficient1
	auxvoltagecoefficient1->set_default_properties(auxvoltagecoefficient1_prop);
	//	Not Polled
	auxvoltagecoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(auxvoltagecoefficient1);

	//	Attribute : AuxiliaryVoltage
	AuxiliaryVoltageAttrib	*auxiliaryvoltage = new AuxiliaryVoltageAttrib();
	Tango::UserDefaultAttrProp	auxiliaryvoltage_prop;
	//	description	not set for AuxiliaryVoltage
	auxiliaryvoltage_prop.set_label("Auxiliary voltage");
	auxiliaryvoltage_prop.set_unit("V");
	auxiliaryvoltage_prop.set_standard_unit("1.0");
	auxiliaryvoltage_prop.set_display_unit("V");
	auxiliaryvoltage_prop.set_format("%2.2f");
	//	max_value	not set for AuxiliaryVoltage
	//	min_value	not set for AuxiliaryVoltage
	//	max_alarm	not set for AuxiliaryVoltage
	//	min_alarm	not set for AuxiliaryVoltage
	//	max_warning	not set for AuxiliaryVoltage
	//	min_warning	not set for AuxiliaryVoltage
	//	delta_t	not set for AuxiliaryVoltage
	//	delta_val	not set for AuxiliaryVoltage
	auxiliaryvoltage->set_default_properties(auxiliaryvoltage_prop);
	//	Not Polled
	auxiliaryvoltage->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(auxiliaryvoltage);

	//	Attribute : CalibrationDate
	CalibrationDateAttrib	*calibrationdate = new CalibrationDateAttrib();
	Tango::UserDefaultAttrProp	calibrationdate_prop;
	//	description	not set for CalibrationDate
	calibrationdate_prop.set_label("Calibration date");
	//	unit	not set for CalibrationDate
	//	standard_unit	not set for CalibrationDate
	//	display_unit	not set for CalibrationDate
	//	format	not set for CalibrationDate
	//	max_value	not set for CalibrationDate
	//	min_value	not set for CalibrationDate
	//	max_alarm	not set for CalibrationDate
	//	min_alarm	not set for CalibrationDate
	//	max_warning	not set for CalibrationDate
	//	min_warning	not set for CalibrationDate
	//	delta_t	not set for CalibrationDate
	//	delta_val	not set for CalibrationDate
	calibrationdate->set_default_properties(calibrationdate_prop);
	//	Not Polled
	calibrationdate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(calibrationdate);

	//	Attribute : Current
	CurrentAttrib	*current = new CurrentAttrib();
	Tango::UserDefaultAttrProp	current_prop;
	//	description	not set for Current
	current_prop.set_label("Current");
	current_prop.set_unit("A");
	current_prop.set_standard_unit("1.0");
	current_prop.set_display_unit("A");
	current_prop.set_format("%8.5f");
	//	max_value	not set for Current
	//	min_value	not set for Current
	//	max_alarm	not set for Current
	//	min_alarm	not set for Current
	//	max_warning	not set for Current
	//	min_warning	not set for Current
	//	delta_t	not set for Current
	//	delta_val	not set for Current
	current->set_default_properties(current_prop);
	//	Not Polled
	current->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(current);

	//	Attribute : CurrentCoefficient0
	CurrentCoefficient0Attrib	*currentcoefficient0 = new CurrentCoefficient0Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient0_prop;
	//	description	not set for CurrentCoefficient0
	currentcoefficient0_prop.set_label("Current coefficient 0");
	//	unit	not set for CurrentCoefficient0
	//	standard_unit	not set for CurrentCoefficient0
	//	display_unit	not set for CurrentCoefficient0
	currentcoefficient0_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient0
	//	min_value	not set for CurrentCoefficient0
	//	max_alarm	not set for CurrentCoefficient0
	//	min_alarm	not set for CurrentCoefficient0
	//	max_warning	not set for CurrentCoefficient0
	//	min_warning	not set for CurrentCoefficient0
	//	delta_t	not set for CurrentCoefficient0
	//	delta_val	not set for CurrentCoefficient0
	currentcoefficient0->set_default_properties(currentcoefficient0_prop);
	//	Not Polled
	currentcoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient0);

	//	Attribute : CurrentCoefficient1
	CurrentCoefficient1Attrib	*currentcoefficient1 = new CurrentCoefficient1Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient1_prop;
	//	description	not set for CurrentCoefficient1
	currentcoefficient1_prop.set_label("Current coefficient 1");
	//	unit	not set for CurrentCoefficient1
	//	standard_unit	not set for CurrentCoefficient1
	//	display_unit	not set for CurrentCoefficient1
	currentcoefficient1_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient1
	//	min_value	not set for CurrentCoefficient1
	//	max_alarm	not set for CurrentCoefficient1
	//	min_alarm	not set for CurrentCoefficient1
	//	max_warning	not set for CurrentCoefficient1
	//	min_warning	not set for CurrentCoefficient1
	//	delta_t	not set for CurrentCoefficient1
	//	delta_val	not set for CurrentCoefficient1
	currentcoefficient1->set_default_properties(currentcoefficient1_prop);
	//	Not Polled
	currentcoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient1);

	//	Attribute : CurrentCoefficient2
	CurrentCoefficient2Attrib	*currentcoefficient2 = new CurrentCoefficient2Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient2_prop;
	//	description	not set for CurrentCoefficient2
	currentcoefficient2_prop.set_label("Current coefficient 2");
	//	unit	not set for CurrentCoefficient2
	//	standard_unit	not set for CurrentCoefficient2
	//	display_unit	not set for CurrentCoefficient2
	currentcoefficient2_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient2
	//	min_value	not set for CurrentCoefficient2
	//	max_alarm	not set for CurrentCoefficient2
	//	min_alarm	not set for CurrentCoefficient2
	//	max_warning	not set for CurrentCoefficient2
	//	min_warning	not set for CurrentCoefficient2
	//	delta_t	not set for CurrentCoefficient2
	//	delta_val	not set for CurrentCoefficient2
	currentcoefficient2->set_default_properties(currentcoefficient2_prop);
	//	Not Polled
	currentcoefficient2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient2);

	//	Attribute : CurrentCoefficient3
	CurrentCoefficient3Attrib	*currentcoefficient3 = new CurrentCoefficient3Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient3_prop;
	//	description	not set for CurrentCoefficient3
	currentcoefficient3_prop.set_label("Current coefficient 3");
	//	unit	not set for CurrentCoefficient3
	//	standard_unit	not set for CurrentCoefficient3
	//	display_unit	not set for CurrentCoefficient3
	currentcoefficient3_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient3
	//	min_value	not set for CurrentCoefficient3
	//	max_alarm	not set for CurrentCoefficient3
	//	min_alarm	not set for CurrentCoefficient3
	//	max_warning	not set for CurrentCoefficient3
	//	min_warning	not set for CurrentCoefficient3
	//	delta_t	not set for CurrentCoefficient3
	//	delta_val	not set for CurrentCoefficient3
	currentcoefficient3->set_default_properties(currentcoefficient3_prop);
	//	Not Polled
	currentcoefficient3->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient3);

	//	Attribute : CurrentCoefficient4
	CurrentCoefficient4Attrib	*currentcoefficient4 = new CurrentCoefficient4Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient4_prop;
	//	description	not set for CurrentCoefficient4
	currentcoefficient4_prop.set_label("Current coefficient 4");
	//	unit	not set for CurrentCoefficient4
	//	standard_unit	not set for CurrentCoefficient4
	//	display_unit	not set for CurrentCoefficient4
	currentcoefficient4_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient4
	//	min_value	not set for CurrentCoefficient4
	//	max_alarm	not set for CurrentCoefficient4
	//	min_alarm	not set for CurrentCoefficient4
	//	max_warning	not set for CurrentCoefficient4
	//	min_warning	not set for CurrentCoefficient4
	//	delta_t	not set for CurrentCoefficient4
	//	delta_val	not set for CurrentCoefficient4
	currentcoefficient4->set_default_properties(currentcoefficient4_prop);
	//	Not Polled
	currentcoefficient4->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient4);

	//	Attribute : CurrentCoefficient5
	CurrentCoefficient5Attrib	*currentcoefficient5 = new CurrentCoefficient5Attrib();
	Tango::UserDefaultAttrProp	currentcoefficient5_prop;
	//	description	not set for CurrentCoefficient5
	currentcoefficient5_prop.set_label("Current coefficient 5");
	//	unit	not set for CurrentCoefficient5
	//	standard_unit	not set for CurrentCoefficient5
	//	display_unit	not set for CurrentCoefficient5
	currentcoefficient5_prop.set_format("%6.9f");
	//	max_value	not set for CurrentCoefficient5
	//	min_value	not set for CurrentCoefficient5
	//	max_alarm	not set for CurrentCoefficient5
	//	min_alarm	not set for CurrentCoefficient5
	//	max_warning	not set for CurrentCoefficient5
	//	min_warning	not set for CurrentCoefficient5
	//	delta_t	not set for CurrentCoefficient5
	//	delta_val	not set for CurrentCoefficient5
	currentcoefficient5->set_default_properties(currentcoefficient5_prop);
	//	Not Polled
	currentcoefficient5->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentcoefficient5);

	//	Attribute : CurrentMax
	CurrentMaxAttrib	*currentmax = new CurrentMaxAttrib();
	Tango::UserDefaultAttrProp	currentmax_prop;
	//	description	not set for CurrentMax
	currentmax_prop.set_label("CurrentMax");
	currentmax_prop.set_unit("A");
	currentmax_prop.set_standard_unit("1.0");
	currentmax_prop.set_display_unit("A");
	currentmax_prop.set_format("%6.5f");
	//	max_value	not set for CurrentMax
	//	min_value	not set for CurrentMax
	//	max_alarm	not set for CurrentMax
	//	min_alarm	not set for CurrentMax
	//	max_warning	not set for CurrentMax
	//	min_warning	not set for CurrentMax
	//	delta_t	not set for CurrentMax
	//	delta_val	not set for CurrentMax
	currentmax->set_default_properties(currentmax_prop);
	//	Not Polled
	currentmax->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentmax);

	//	Attribute : CurrentMin
	CurrentMinAttrib	*currentmin = new CurrentMinAttrib();
	Tango::UserDefaultAttrProp	currentmin_prop;
	//	description	not set for CurrentMin
	currentmin_prop.set_label("CurrentMin");
	currentmin_prop.set_unit("A");
	currentmin_prop.set_standard_unit("1.0");
	currentmin_prop.set_display_unit("A");
	currentmin_prop.set_format("%6.5f");
	//	max_value	not set for CurrentMin
	//	min_value	not set for CurrentMin
	//	max_alarm	not set for CurrentMin
	//	min_alarm	not set for CurrentMin
	//	max_warning	not set for CurrentMin
	//	min_warning	not set for CurrentMin
	//	delta_t	not set for CurrentMin
	//	delta_val	not set for CurrentMin
	currentmin->set_default_properties(currentmin_prop);
	//	Not Polled
	currentmin->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentmin);

	//	Attribute : CurrentSet
	CurrentSetAttrib	*currentset = new CurrentSetAttrib();
	Tango::UserDefaultAttrProp	currentset_prop;
	//	description	not set for CurrentSet
	currentset_prop.set_label("Current set");
	currentset_prop.set_unit("A");
	currentset_prop.set_standard_unit("1.0");
	currentset_prop.set_display_unit("A");
	currentset_prop.set_format("%6.5f");
	//	max_value	not set for CurrentSet
	//	min_value	not set for CurrentSet
	//	max_alarm	not set for CurrentSet
	//	min_alarm	not set for CurrentSet
	//	max_warning	not set for CurrentSet
	//	min_warning	not set for CurrentSet
	//	delta_t	not set for CurrentSet
	//	delta_val	not set for CurrentSet
	currentset->set_default_properties(currentset_prop);
	//	Not Polled
	currentset->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(currentset);

	//	Attribute : DCCurrentCoefficient0
	DCCurrentCoefficient0Attrib	*dccurrentcoefficient0 = new DCCurrentCoefficient0Attrib();
	Tango::UserDefaultAttrProp	dccurrentcoefficient0_prop;
	//	description	not set for DCCurrentCoefficient0
	dccurrentcoefficient0_prop.set_label("DC current coefficient 0");
	//	unit	not set for DCCurrentCoefficient0
	//	standard_unit	not set for DCCurrentCoefficient0
	//	display_unit	not set for DCCurrentCoefficient0
	dccurrentcoefficient0_prop.set_format("%6.5f");
	//	max_value	not set for DCCurrentCoefficient0
	//	min_value	not set for DCCurrentCoefficient0
	//	max_alarm	not set for DCCurrentCoefficient0
	//	min_alarm	not set for DCCurrentCoefficient0
	//	max_warning	not set for DCCurrentCoefficient0
	//	min_warning	not set for DCCurrentCoefficient0
	//	delta_t	not set for DCCurrentCoefficient0
	//	delta_val	not set for DCCurrentCoefficient0
	dccurrentcoefficient0->set_default_properties(dccurrentcoefficient0_prop);
	//	Not Polled
	dccurrentcoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dccurrentcoefficient0);

	//	Attribute : DCCurrentCoefficient1
	DCCurrentCoefficient1Attrib	*dccurrentcoefficient1 = new DCCurrentCoefficient1Attrib();
	Tango::UserDefaultAttrProp	dccurrentcoefficient1_prop;
	//	description	not set for DCCurrentCoefficient1
	dccurrentcoefficient1_prop.set_label("DC current coefficient 1");
	//	unit	not set for DCCurrentCoefficient1
	//	standard_unit	not set for DCCurrentCoefficient1
	//	display_unit	not set for DCCurrentCoefficient1
	dccurrentcoefficient1_prop.set_format("%6.5f");
	//	max_value	not set for DCCurrentCoefficient1
	//	min_value	not set for DCCurrentCoefficient1
	//	max_alarm	not set for DCCurrentCoefficient1
	//	min_alarm	not set for DCCurrentCoefficient1
	//	max_warning	not set for DCCurrentCoefficient1
	//	min_warning	not set for DCCurrentCoefficient1
	//	delta_t	not set for DCCurrentCoefficient1
	//	delta_val	not set for DCCurrentCoefficient1
	dccurrentcoefficient1->set_default_properties(dccurrentcoefficient1_prop);
	//	Not Polled
	dccurrentcoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dccurrentcoefficient1);

	//	Attribute : DCLinkVoltage
	DCLinkVoltageAttrib	*dclinkvoltage = new DCLinkVoltageAttrib();
	Tango::UserDefaultAttrProp	dclinkvoltage_prop;
	//	description	not set for DCLinkVoltage
	dclinkvoltage_prop.set_label("DC link voltage");
	dclinkvoltage_prop.set_unit("V");
	dclinkvoltage_prop.set_standard_unit("1.0");
	dclinkvoltage_prop.set_display_unit("V");
	dclinkvoltage_prop.set_format("%2.2f");
	//	max_value	not set for DCLinkVoltage
	//	min_value	not set for DCLinkVoltage
	//	max_alarm	not set for DCLinkVoltage
	//	min_alarm	not set for DCLinkVoltage
	//	max_warning	not set for DCLinkVoltage
	//	min_warning	not set for DCLinkVoltage
	//	delta_t	not set for DCLinkVoltage
	//	delta_val	not set for DCLinkVoltage
	dclinkvoltage->set_default_properties(dclinkvoltage_prop);
	//	Not Polled
	dclinkvoltage->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dclinkvoltage);

	//	Attribute : DCurr
	DCurrAttrib	*dcurr = new DCurrAttrib();
	Tango::UserDefaultAttrProp	dcurr_prop;
	//	description	not set for DCurr
	//	label	not set for DCurr
	dcurr_prop.set_unit("A");
	dcurr_prop.set_standard_unit("1.0");
	dcurr_prop.set_display_unit("A");
	dcurr_prop.set_format("%6.6f");
	//	max_value	not set for DCurr
	//	min_value	not set for DCurr
	//	max_alarm	not set for DCurr
	//	min_alarm	not set for DCurr
	//	max_warning	not set for DCurr
	//	min_warning	not set for DCurr
	//	delta_t	not set for DCurr
	//	delta_val	not set for DCurr
	dcurr->set_default_properties(dcurr_prop);
	//	Not Polled
	dcurr->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dcurr);

	//	Attribute : HeatsinkTempCoefficient0
	HeatsinkTempCoefficient0Attrib	*heatsinktempcoefficient0 = new HeatsinkTempCoefficient0Attrib();
	Tango::UserDefaultAttrProp	heatsinktempcoefficient0_prop;
	//	description	not set for HeatsinkTempCoefficient0
	heatsinktempcoefficient0_prop.set_label("Heatsink temperature coefficient 0");
	//	unit	not set for HeatsinkTempCoefficient0
	//	standard_unit	not set for HeatsinkTempCoefficient0
	//	display_unit	not set for HeatsinkTempCoefficient0
	heatsinktempcoefficient0_prop.set_format("%6.5f");
	//	max_value	not set for HeatsinkTempCoefficient0
	//	min_value	not set for HeatsinkTempCoefficient0
	//	max_alarm	not set for HeatsinkTempCoefficient0
	//	min_alarm	not set for HeatsinkTempCoefficient0
	//	max_warning	not set for HeatsinkTempCoefficient0
	//	min_warning	not set for HeatsinkTempCoefficient0
	//	delta_t	not set for HeatsinkTempCoefficient0
	//	delta_val	not set for HeatsinkTempCoefficient0
	heatsinktempcoefficient0->set_default_properties(heatsinktempcoefficient0_prop);
	//	Not Polled
	heatsinktempcoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(heatsinktempcoefficient0);

	//	Attribute : HeatsinkTempCoefficient1
	HeatsinkTempCoefficient1Attrib	*heatsinktempcoefficient1 = new HeatsinkTempCoefficient1Attrib();
	Tango::UserDefaultAttrProp	heatsinktempcoefficient1_prop;
	//	description	not set for HeatsinkTempCoefficient1
	heatsinktempcoefficient1_prop.set_label("Heatsink temperature coefficient 1");
	//	unit	not set for HeatsinkTempCoefficient1
	//	standard_unit	not set for HeatsinkTempCoefficient1
	//	display_unit	not set for HeatsinkTempCoefficient1
	heatsinktempcoefficient1_prop.set_format("%6.5f");
	//	max_value	not set for HeatsinkTempCoefficient1
	//	min_value	not set for HeatsinkTempCoefficient1
	//	max_alarm	not set for HeatsinkTempCoefficient1
	//	min_alarm	not set for HeatsinkTempCoefficient1
	//	max_warning	not set for HeatsinkTempCoefficient1
	//	min_warning	not set for HeatsinkTempCoefficient1
	//	delta_t	not set for HeatsinkTempCoefficient1
	//	delta_val	not set for HeatsinkTempCoefficient1
	heatsinktempcoefficient1->set_default_properties(heatsinktempcoefficient1_prop);
	//	Not Polled
	heatsinktempcoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(heatsinktempcoefficient1);

	//	Attribute : HeatsinkTemperature
	HeatsinkTemperatureAttrib	*heatsinktemperature = new HeatsinkTemperatureAttrib();
	Tango::UserDefaultAttrProp	heatsinktemperature_prop;
	//	description	not set for HeatsinkTemperature
	heatsinktemperature_prop.set_label("Heatsink temperature");
	heatsinktemperature_prop.set_unit("C");
	heatsinktemperature_prop.set_standard_unit("1.0");
	heatsinktemperature_prop.set_display_unit("C");
	heatsinktemperature_prop.set_format("%2.1f");
	//	max_value	not set for HeatsinkTemperature
	//	min_value	not set for HeatsinkTemperature
	//	max_alarm	not set for HeatsinkTemperature
	//	min_alarm	not set for HeatsinkTemperature
	//	max_warning	not set for HeatsinkTemperature
	//	min_warning	not set for HeatsinkTemperature
	//	delta_t	not set for HeatsinkTemperature
	//	delta_val	not set for HeatsinkTemperature
	heatsinktemperature->set_default_properties(heatsinktemperature_prop);
	//	Not Polled
	heatsinktemperature->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(heatsinktemperature);

	//	Attribute : KDCoefficient
	KDCoefficientAttrib	*kdcoefficient = new KDCoefficientAttrib();
	Tango::UserDefaultAttrProp	kdcoefficient_prop;
	//	description	not set for KDCoefficient
	kdcoefficient_prop.set_label("KD coefficient");
	//	unit	not set for KDCoefficient
	//	standard_unit	not set for KDCoefficient
	//	display_unit	not set for KDCoefficient
	kdcoefficient_prop.set_format("%13.1f");
	//	max_value	not set for KDCoefficient
	//	min_value	not set for KDCoefficient
	//	max_alarm	not set for KDCoefficient
	//	min_alarm	not set for KDCoefficient
	//	max_warning	not set for KDCoefficient
	//	min_warning	not set for KDCoefficient
	//	delta_t	not set for KDCoefficient
	//	delta_val	not set for KDCoefficient
	kdcoefficient->set_default_properties(kdcoefficient_prop);
	//	Not Polled
	kdcoefficient->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(kdcoefficient);

	//	Attribute : KFFCoefficient
	KFFCoefficientAttrib	*kffcoefficient = new KFFCoefficientAttrib();
	Tango::UserDefaultAttrProp	kffcoefficient_prop;
	//	description	not set for KFFCoefficient
	kffcoefficient_prop.set_label("KFF coefficient");
	//	unit	not set for KFFCoefficient
	//	standard_unit	not set for KFFCoefficient
	//	display_unit	not set for KFFCoefficient
	kffcoefficient_prop.set_format("%7.4f");
	//	max_value	not set for KFFCoefficient
	//	min_value	not set for KFFCoefficient
	//	max_alarm	not set for KFFCoefficient
	//	min_alarm	not set for KFFCoefficient
	//	max_warning	not set for KFFCoefficient
	//	min_warning	not set for KFFCoefficient
	//	delta_t	not set for KFFCoefficient
	//	delta_val	not set for KFFCoefficient
	kffcoefficient->set_default_properties(kffcoefficient_prop);
	//	Not Polled
	kffcoefficient->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(kffcoefficient);

	//	Attribute : KICoefficient
	KICoefficientAttrib	*kicoefficient = new KICoefficientAttrib();
	Tango::UserDefaultAttrProp	kicoefficient_prop;
	//	description	not set for KICoefficient
	kicoefficient_prop.set_label("KI coefficient");
	//	unit	not set for KICoefficient
	//	standard_unit	not set for KICoefficient
	//	display_unit	not set for KICoefficient
	kicoefficient_prop.set_format("%13.1f");
	//	max_value	not set for KICoefficient
	//	min_value	not set for KICoefficient
	//	max_alarm	not set for KICoefficient
	//	min_alarm	not set for KICoefficient
	//	max_warning	not set for KICoefficient
	//	min_warning	not set for KICoefficient
	//	delta_t	not set for KICoefficient
	//	delta_val	not set for KICoefficient
	kicoefficient->set_default_properties(kicoefficient_prop);
	//	Not Polled
	kicoefficient->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(kicoefficient);

	//	Attribute : KPCoefficient
	KPCoefficientAttrib	*kpcoefficient = new KPCoefficientAttrib();
	Tango::UserDefaultAttrProp	kpcoefficient_prop;
	//	description	not set for KPCoefficient
	kpcoefficient_prop.set_label("KP coefficient");
	//	unit	not set for KPCoefficient
	//	standard_unit	not set for KPCoefficient
	//	display_unit	not set for KPCoefficient
	kpcoefficient_prop.set_format("%13.1f");
	//	max_value	not set for KPCoefficient
	//	min_value	not set for KPCoefficient
	//	max_alarm	not set for KPCoefficient
	//	min_alarm	not set for KPCoefficient
	//	max_warning	not set for KPCoefficient
	//	min_warning	not set for KPCoefficient
	//	delta_t	not set for KPCoefficient
	//	delta_val	not set for KPCoefficient
	kpcoefficient->set_default_properties(kpcoefficient_prop);
	//	Not Polled
	kpcoefficient->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(kpcoefficient);

	//	Attribute : Model
	ModelAttrib	*model = new ModelAttrib();
	Tango::UserDefaultAttrProp	model_prop;
	//	description	not set for Model
	model_prop.set_label("Model");
	//	unit	not set for Model
	//	standard_unit	not set for Model
	//	display_unit	not set for Model
	//	format	not set for Model
	//	max_value	not set for Model
	//	min_value	not set for Model
	//	max_alarm	not set for Model
	//	min_alarm	not set for Model
	//	max_warning	not set for Model
	//	min_warning	not set for Model
	//	delta_t	not set for Model
	//	delta_val	not set for Model
	model->set_default_properties(model_prop);
	//	Not Polled
	model->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(model);

	//	Attribute : PulseDuration
	PulseDurationAttrib	*pulseduration = new PulseDurationAttrib();
	Tango::UserDefaultAttrProp	pulseduration_prop;
	//	description	not set for PulseDuration
	pulseduration_prop.set_label("Pulse duration");
	pulseduration_prop.set_unit("ms");
	pulseduration_prop.set_standard_unit("1.0");
	pulseduration_prop.set_display_unit("ms");
	pulseduration_prop.set_format("%6.6f");
	//	max_value	not set for PulseDuration
	//	min_value	not set for PulseDuration
	//	max_alarm	not set for PulseDuration
	//	min_alarm	not set for PulseDuration
	//	max_warning	not set for PulseDuration
	//	min_warning	not set for PulseDuration
	//	delta_t	not set for PulseDuration
	//	delta_val	not set for PulseDuration
	pulseduration->set_default_properties(pulseduration_prop);
	//	Not Polled
	pulseduration->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pulseduration);

	//	Attribute : SerialNumber
	SerialNumberAttrib	*serialnumber = new SerialNumberAttrib();
	Tango::UserDefaultAttrProp	serialnumber_prop;
	//	description	not set for SerialNumber
	serialnumber_prop.set_label("Serial number");
	//	unit	not set for SerialNumber
	//	standard_unit	not set for SerialNumber
	//	display_unit	not set for SerialNumber
	//	format	not set for SerialNumber
	//	max_value	not set for SerialNumber
	//	min_value	not set for SerialNumber
	//	max_alarm	not set for SerialNumber
	//	min_alarm	not set for SerialNumber
	//	max_warning	not set for SerialNumber
	//	min_warning	not set for SerialNumber
	//	delta_t	not set for SerialNumber
	//	delta_val	not set for SerialNumber
	serialnumber->set_default_properties(serialnumber_prop);
	//	Not Polled
	serialnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(serialnumber);

	//	Attribute : SlewRate
	SlewRateAttrib	*slewrate = new SlewRateAttrib();
	Tango::UserDefaultAttrProp	slewrate_prop;
	//	description	not set for SlewRate
	slewrate_prop.set_label("Slewrate");
	slewrate_prop.set_unit("A/s");
	slewrate_prop.set_standard_unit("1.0");
	slewrate_prop.set_display_unit("A/s");
	slewrate_prop.set_format("%6.6f");
	//	max_value	not set for SlewRate
	//	min_value	not set for SlewRate
	//	max_alarm	not set for SlewRate
	//	min_alarm	not set for SlewRate
	//	max_warning	not set for SlewRate
	//	min_warning	not set for SlewRate
	//	delta_t	not set for SlewRate
	//	delta_val	not set for SlewRate
	slewrate->set_default_properties(slewrate_prop);
	//	Not Polled
	slewrate->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(slewrate);

	//	Attribute : Voltage
	VoltageAttrib	*voltage = new VoltageAttrib();
	Tango::UserDefaultAttrProp	voltage_prop;
	//	description	not set for Voltage
	voltage_prop.set_label("Voltage");
	voltage_prop.set_unit("V");
	voltage_prop.set_standard_unit("1.0");
	voltage_prop.set_display_unit("V");
	voltage_prop.set_format("%3.2f");
	//	max_value	not set for Voltage
	//	min_value	not set for Voltage
	//	max_alarm	not set for Voltage
	//	min_alarm	not set for Voltage
	//	max_warning	not set for Voltage
	//	min_warning	not set for Voltage
	//	delta_t	not set for Voltage
	//	delta_val	not set for Voltage
	voltage->set_default_properties(voltage_prop);
	//	Not Polled
	voltage->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(voltage);

	//	Attribute : VoltageCoefficient0
	VoltageCoefficient0Attrib	*voltagecoefficient0 = new VoltageCoefficient0Attrib();
	Tango::UserDefaultAttrProp	voltagecoefficient0_prop;
	//	description	not set for VoltageCoefficient0
	voltagecoefficient0_prop.set_label("Voltage coefficient 0");
	//	unit	not set for VoltageCoefficient0
	//	standard_unit	not set for VoltageCoefficient0
	//	display_unit	not set for VoltageCoefficient0
	voltagecoefficient0_prop.set_format("%6.4f");
	//	max_value	not set for VoltageCoefficient0
	//	min_value	not set for VoltageCoefficient0
	//	max_alarm	not set for VoltageCoefficient0
	//	min_alarm	not set for VoltageCoefficient0
	//	max_warning	not set for VoltageCoefficient0
	//	min_warning	not set for VoltageCoefficient0
	//	delta_t	not set for VoltageCoefficient0
	//	delta_val	not set for VoltageCoefficient0
	voltagecoefficient0->set_default_properties(voltagecoefficient0_prop);
	//	Not Polled
	voltagecoefficient0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(voltagecoefficient0);

	//	Attribute : VoltageCoefficient1
	VoltageCoefficient1Attrib	*voltagecoefficient1 = new VoltageCoefficient1Attrib();
	Tango::UserDefaultAttrProp	voltagecoefficient1_prop;
	//	description	not set for VoltageCoefficient1
	voltagecoefficient1_prop.set_label("Voltage coefficient 1");
	//	unit	not set for VoltageCoefficient1
	//	standard_unit	not set for VoltageCoefficient1
	//	display_unit	not set for VoltageCoefficient1
	voltagecoefficient1_prop.set_format("%6.4f");
	//	max_value	not set for VoltageCoefficient1
	//	min_value	not set for VoltageCoefficient1
	//	max_alarm	not set for VoltageCoefficient1
	//	min_alarm	not set for VoltageCoefficient1
	//	max_warning	not set for VoltageCoefficient1
	//	min_warning	not set for VoltageCoefficient1
	//	delta_t	not set for VoltageCoefficient1
	//	delta_val	not set for VoltageCoefficient1
	voltagecoefficient1->set_default_properties(voltagecoefficient1_prop);
	//	Not Polled
	voltagecoefficient1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(voltagecoefficient1);

	//	Attribute : PsStat
	PsStatAttrib	*psstat = new PsStatAttrib();
	Tango::UserDefaultAttrProp	psstat_prop;
	//	description	not set for PsStat
	//	label	not set for PsStat
	//	unit	not set for PsStat
	//	standard_unit	not set for PsStat
	//	display_unit	not set for PsStat
	//	format	not set for PsStat
	//	max_value	not set for PsStat
	//	min_value	not set for PsStat
	//	max_alarm	not set for PsStat
	//	min_alarm	not set for PsStat
	//	max_warning	not set for PsStat
	//	min_warning	not set for PsStat
	//	delta_t	not set for PsStat
	//	delta_val	not set for PsStat
	psstat->set_default_properties(psstat_prop);
	//	Not Polled
	psstat->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(psstat);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(A2720Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : A2720Class::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void A2720Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(A2720Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::pipe_factory_before
	/*----- PROTECTED REGION ID(A2720Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : A2720Class::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void A2720Class::command_factory()
{
	/*----- PROTECTED REGION ID(A2720Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::command_factory_before
	//	Call command_factory for inherited class
	Socket2Client_ns::Socket2ClientClass::command_factory();

	//	Command Abort
	AbortClass	*pAbortCmd =
		new AbortClass("Abort",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAbortCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command StartCycling
	StartCyclingClass	*pStartCyclingCmd =
		new StartCyclingClass("StartCycling",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStartCyclingCmd);



	/*----- PROTECTED REGION ID(A2720Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		A2720Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void A2720Class::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(A2720Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		A2720Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void A2720Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		A2720 *dev = static_cast<A2720 *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(A2720Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : A2720Class::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *A2720Class::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(A2720Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	A2720Class::Additional Methods
} //	namespace
