/*----- PROTECTED REGION ID(A2720Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        A2720Class.h
//
// description : Include for the A2720 root class.
//               This class is the singleton class for
//                the A2720 device class.
//               It contains all properties and methods which the 
//               A2720 requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2018-02-19 16:52:13 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef A2720Class_H
#define A2720Class_H

#include <tango.h>
#include <Socket2ClientClass.h>
#include <A2720.h>


/*----- PROTECTED REGION END -----*/	//	A2720Class.h


namespace A2720_ns
{
/*----- PROTECTED REGION ID(A2720Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	A2720Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ADCTempCoefficient0 class definition
class ADCTempCoefficient0Attrib: public Tango::Attr
{
public:
	ADCTempCoefficient0Attrib():Attr("ADCTempCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~ADCTempCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_ADCTempCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_ADCTempCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_ADCTempCoefficient0_allowed(ty);}
};

//	Attribute ADCTempCoefficient1 class definition
class ADCTempCoefficient1Attrib: public Tango::Attr
{
public:
	ADCTempCoefficient1Attrib():Attr("ADCTempCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~ADCTempCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_ADCTempCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_ADCTempCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_ADCTempCoefficient1_allowed(ty);}
};

//	Attribute ADCTemperature class definition
class ADCTemperatureAttrib: public Tango::Attr
{
public:
	ADCTemperatureAttrib():Attr("ADCTemperature",
			Tango::DEV_FLOAT, Tango::READ) {}
	~ADCTemperatureAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_ADCTemperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_ADCTemperature_allowed(ty);}
};

//	Attribute AuxVoltageCoefficient0 class definition
class AuxVoltageCoefficient0Attrib: public Tango::Attr
{
public:
	AuxVoltageCoefficient0Attrib():Attr("AuxVoltageCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~AuxVoltageCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_AuxVoltageCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_AuxVoltageCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_AuxVoltageCoefficient0_allowed(ty);}
};

//	Attribute AuxVoltageCoefficient1 class definition
class AuxVoltageCoefficient1Attrib: public Tango::Attr
{
public:
	AuxVoltageCoefficient1Attrib():Attr("AuxVoltageCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~AuxVoltageCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_AuxVoltageCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_AuxVoltageCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_AuxVoltageCoefficient1_allowed(ty);}
};

//	Attribute AuxiliaryVoltage class definition
class AuxiliaryVoltageAttrib: public Tango::Attr
{
public:
	AuxiliaryVoltageAttrib():Attr("AuxiliaryVoltage",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~AuxiliaryVoltageAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_AuxiliaryVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_AuxiliaryVoltage_allowed(ty);}
};

//	Attribute CalibrationDate class definition
class CalibrationDateAttrib: public Tango::Attr
{
public:
	CalibrationDateAttrib():Attr("CalibrationDate",
			Tango::DEV_STRING, Tango::READ) {}
	~CalibrationDateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CalibrationDate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CalibrationDate_allowed(ty);}
};

//	Attribute Current class definition
class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib():Attr("Current",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CurrentAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_Current(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_Current_allowed(ty);}
};

//	Attribute CurrentCoefficient0 class definition
class CurrentCoefficient0Attrib: public Tango::Attr
{
public:
	CurrentCoefficient0Attrib():Attr("CurrentCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient0_allowed(ty);}
};

//	Attribute CurrentCoefficient1 class definition
class CurrentCoefficient1Attrib: public Tango::Attr
{
public:
	CurrentCoefficient1Attrib():Attr("CurrentCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient1_allowed(ty);}
};

//	Attribute CurrentCoefficient2 class definition
class CurrentCoefficient2Attrib: public Tango::Attr
{
public:
	CurrentCoefficient2Attrib():Attr("CurrentCoefficient2",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient2Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient2_allowed(ty);}
};

//	Attribute CurrentCoefficient3 class definition
class CurrentCoefficient3Attrib: public Tango::Attr
{
public:
	CurrentCoefficient3Attrib():Attr("CurrentCoefficient3",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient3Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient3(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient3_allowed(ty);}
};

//	Attribute CurrentCoefficient4 class definition
class CurrentCoefficient4Attrib: public Tango::Attr
{
public:
	CurrentCoefficient4Attrib():Attr("CurrentCoefficient4",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient4Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient4(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient4_allowed(ty);}
};

//	Attribute CurrentCoefficient5 class definition
class CurrentCoefficient5Attrib: public Tango::Attr
{
public:
	CurrentCoefficient5Attrib():Attr("CurrentCoefficient5",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentCoefficient5Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentCoefficient5(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentCoefficient5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentCoefficient5_allowed(ty);}
};

//	Attribute CurrentMax class definition
class CurrentMaxAttrib: public Tango::Attr
{
public:
	CurrentMaxAttrib():Attr("CurrentMax",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentMaxAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentMax_allowed(ty);}
};

//	Attribute CurrentMin class definition
class CurrentMinAttrib: public Tango::Attr
{
public:
	CurrentMinAttrib():Attr("CurrentMin",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~CurrentMinAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_CurrentMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentMin_allowed(ty);}
};

//	Attribute CurrentSet class definition
class CurrentSetAttrib: public Tango::Attr
{
public:
	CurrentSetAttrib():Attr("CurrentSet",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~CurrentSetAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_CurrentSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_CurrentSet_allowed(ty);}
};

//	Attribute DCCurrentCoefficient0 class definition
class DCCurrentCoefficient0Attrib: public Tango::Attr
{
public:
	DCCurrentCoefficient0Attrib():Attr("DCCurrentCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~DCCurrentCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_DCCurrentCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_DCCurrentCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_DCCurrentCoefficient0_allowed(ty);}
};

//	Attribute DCCurrentCoefficient1 class definition
class DCCurrentCoefficient1Attrib: public Tango::Attr
{
public:
	DCCurrentCoefficient1Attrib():Attr("DCCurrentCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~DCCurrentCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_DCCurrentCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_DCCurrentCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_DCCurrentCoefficient1_allowed(ty);}
};

//	Attribute DCLinkVoltage class definition
class DCLinkVoltageAttrib: public Tango::Attr
{
public:
	DCLinkVoltageAttrib():Attr("DCLinkVoltage",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~DCLinkVoltageAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_DCLinkVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_DCLinkVoltage_allowed(ty);}
};

//	Attribute DCurr class definition
class DCurrAttrib: public Tango::Attr
{
public:
	DCurrAttrib():Attr("DCurr",
			Tango::DEV_DOUBLE, Tango::WRITE) {}
	~DCurrAttrib() {}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_DCurr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_DCurr_allowed(ty);}
};

//	Attribute HeatsinkTempCoefficient0 class definition
class HeatsinkTempCoefficient0Attrib: public Tango::Attr
{
public:
	HeatsinkTempCoefficient0Attrib():Attr("HeatsinkTempCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~HeatsinkTempCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_HeatsinkTempCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_HeatsinkTempCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_HeatsinkTempCoefficient0_allowed(ty);}
};

//	Attribute HeatsinkTempCoefficient1 class definition
class HeatsinkTempCoefficient1Attrib: public Tango::Attr
{
public:
	HeatsinkTempCoefficient1Attrib():Attr("HeatsinkTempCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~HeatsinkTempCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_HeatsinkTempCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_HeatsinkTempCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_HeatsinkTempCoefficient1_allowed(ty);}
};

//	Attribute HeatsinkTemperature class definition
class HeatsinkTemperatureAttrib: public Tango::Attr
{
public:
	HeatsinkTemperatureAttrib():Attr("HeatsinkTemperature",
			Tango::DEV_FLOAT, Tango::READ) {}
	~HeatsinkTemperatureAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_HeatsinkTemperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_HeatsinkTemperature_allowed(ty);}
};

//	Attribute KDCoefficient class definition
class KDCoefficientAttrib: public Tango::Attr
{
public:
	KDCoefficientAttrib():Attr("KDCoefficient",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~KDCoefficientAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_KDCoefficient(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_KDCoefficient(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_KDCoefficient_allowed(ty);}
};

//	Attribute KFFCoefficient class definition
class KFFCoefficientAttrib: public Tango::Attr
{
public:
	KFFCoefficientAttrib():Attr("KFFCoefficient",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~KFFCoefficientAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_KFFCoefficient(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_KFFCoefficient(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_KFFCoefficient_allowed(ty);}
};

//	Attribute KICoefficient class definition
class KICoefficientAttrib: public Tango::Attr
{
public:
	KICoefficientAttrib():Attr("KICoefficient",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~KICoefficientAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_KICoefficient(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_KICoefficient(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_KICoefficient_allowed(ty);}
};

//	Attribute KPCoefficient class definition
class KPCoefficientAttrib: public Tango::Attr
{
public:
	KPCoefficientAttrib():Attr("KPCoefficient",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~KPCoefficientAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_KPCoefficient(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_KPCoefficient(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_KPCoefficient_allowed(ty);}
};

//	Attribute Model class definition
class ModelAttrib: public Tango::Attr
{
public:
	ModelAttrib():Attr("Model",
			Tango::DEV_STRING, Tango::READ) {}
	~ModelAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_Model(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_Model_allowed(ty);}
};

//	Attribute PulseDuration class definition
class PulseDurationAttrib: public Tango::Attr
{
public:
	PulseDurationAttrib():Attr("PulseDuration",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~PulseDurationAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_PulseDuration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_PulseDuration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_PulseDuration_allowed(ty);}
};

//	Attribute SerialNumber class definition
class SerialNumberAttrib: public Tango::Attr
{
public:
	SerialNumberAttrib():Attr("SerialNumber",
			Tango::DEV_STRING, Tango::READ) {}
	~SerialNumberAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_SerialNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_SerialNumber_allowed(ty);}
};

//	Attribute SlewRate class definition
class SlewRateAttrib: public Tango::Attr
{
public:
	SlewRateAttrib():Attr("SlewRate",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~SlewRateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_SlewRate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_SlewRate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_SlewRate_allowed(ty);}
};

//	Attribute Voltage class definition
class VoltageAttrib: public Tango::Attr
{
public:
	VoltageAttrib():Attr("Voltage",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~VoltageAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_Voltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_Voltage_allowed(ty);}
};

//	Attribute VoltageCoefficient0 class definition
class VoltageCoefficient0Attrib: public Tango::Attr
{
public:
	VoltageCoefficient0Attrib():Attr("VoltageCoefficient0",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~VoltageCoefficient0Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_VoltageCoefficient0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_VoltageCoefficient0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_VoltageCoefficient0_allowed(ty);}
};

//	Attribute VoltageCoefficient1 class definition
class VoltageCoefficient1Attrib: public Tango::Attr
{
public:
	VoltageCoefficient1Attrib():Attr("VoltageCoefficient1",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {}
	~VoltageCoefficient1Attrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_VoltageCoefficient1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<A2720 *>(dev))->write_VoltageCoefficient1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_VoltageCoefficient1_allowed(ty);}
};

//	Attribute PsStat class definition
class PsStatAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for PsStat attribute
	const static long X_DATA_SIZE = 10;
	PsStatAttrib():SpectrumAttr("PsStat",
			Tango::DEV_BOOLEAN, Tango::READ, PsStatAttrib::X_DATA_SIZE) {}
	~PsStatAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<A2720 *>(dev))->read_PsStat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<A2720 *>(dev))->is_PsStat_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Abort class definition
class AbortClass : public Tango::Command
{
public:
	AbortClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	AbortClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~AbortClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<A2720 *>(dev))->is_Abort_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OffClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<A2720 *>(dev))->is_Off_allowed(any);}
};

//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OnClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<A2720 *>(dev))->is_On_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<A2720 *>(dev))->is_Reset_allowed(any);}
};

//	Command StartCycling class definition
class StartCyclingClass : public Tango::Command
{
public:
	StartCyclingClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	StartCyclingClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~StartCyclingClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<A2720 *>(dev))->is_StartCycling_allowed(any);}
};


/**
 *	The A2720Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  A2720Class : public Socket2Client_ns::Socket2ClientClass
#else
class A2720Class : public Socket2Client_ns::Socket2ClientClass
#endif
{
	/*----- PROTECTED REGION ID(A2720Class::Additional DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	A2720Class::Additional DServer data members

	public:
		//	Class properties data members
		//	CycEndCurr:	
		Tango::DevDouble	cycEndCurr;
		//	CycMaxCurr:	
		Tango::DevDouble	cycMaxCurr;
		//	CycMinCurr:	
		Tango::DevDouble	cycMinCurr;
		//	CycNumTimes:	
		Tango::DevULong	cycNumTimes;
		//	CycRampSlopeCurr:	
		Tango::DevDouble	cycRampSlopeCurr;
		//	CycStartCurr:	
		Tango::DevDouble	cycStartCurr;
		//	CycWaitTime:	
		Tango::DevULong	cycWaitTime;
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static A2720Class *init(const char *);
		static A2720Class *instance();
		~A2720Class();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		A2720Class(std::string &);
		static A2720Class *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	A2720_H
