/*----- PROTECTED REGION ID(A2720StateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: A2720StateMachine.cpp,v 1.4 2018-02-19 16:52:13 alessio Exp $";
//=============================================================================
//
// file :        A2720StateMachine.cpp
//
// description : State machine file for the A2720 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.4 $
// $Date: 2018-02-19 16:52:13 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <A2720.h>

/*----- PROTECTED REGION END -----*/	//	A2720::A2720StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  OFF      |  
//  FAULT    |  
//  UNKNOWN  |  
//  MOVING   |  
//  ALARM    |  


namespace A2720_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : A2720::is_ADCTempCoefficient0_allowed()
 *	Description: Execution allowed for ADCTempCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_ADCTempCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::ADCTempCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ADCTempCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::ADCTempCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ADCTempCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_ADCTempCoefficient1_allowed()
 *	Description: Execution allowed for ADCTempCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_ADCTempCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::ADCTempCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ADCTempCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::ADCTempCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ADCTempCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_ADCTemperature_allowed()
 *	Description: Execution allowed for ADCTemperature attribute
 */
//--------------------------------------------------------
bool A2720::is_ADCTemperature_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::ADCTemperatureStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::ADCTemperatureStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_AuxVoltageCoefficient0_allowed()
 *	Description: Execution allowed for AuxVoltageCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_AuxVoltageCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::AuxVoltageCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::AuxVoltageCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::AuxVoltageCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::AuxVoltageCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_AuxVoltageCoefficient1_allowed()
 *	Description: Execution allowed for AuxVoltageCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_AuxVoltageCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::AuxVoltageCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::AuxVoltageCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::AuxVoltageCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::AuxVoltageCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_AuxiliaryVoltage_allowed()
 *	Description: Execution allowed for AuxiliaryVoltage attribute
 */
//--------------------------------------------------------
bool A2720::is_AuxiliaryVoltage_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::AuxiliaryVoltageStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::AuxiliaryVoltageStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CalibrationDate_allowed()
 *	Description: Execution allowed for CalibrationDate attribute
 */
//--------------------------------------------------------
bool A2720::is_CalibrationDate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::CalibrationDateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CalibrationDateStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Current_allowed()
 *	Description: Execution allowed for Current attribute
 */
//--------------------------------------------------------
bool A2720::is_Current_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient0_allowed()
 *	Description: Execution allowed for CurrentCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient1_allowed()
 *	Description: Execution allowed for CurrentCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient2_allowed()
 *	Description: Execution allowed for CurrentCoefficient2 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient2StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient2StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient3_allowed()
 *	Description: Execution allowed for CurrentCoefficient3 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient3_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient3StateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient3StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient3StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient3StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient4_allowed()
 *	Description: Execution allowed for CurrentCoefficient4 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient4_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient4StateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient4StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient4StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient4StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentCoefficient5_allowed()
 *	Description: Execution allowed for CurrentCoefficient5 attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentCoefficient5_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient5StateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient5StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentCoefficient5StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentCoefficient5StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentMax_allowed()
 *	Description: Execution allowed for CurrentMax attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentMaxStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentMaxStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentMaxStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentMin_allowed()
 *	Description: Execution allowed for CurrentMin attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentMinStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentMinStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::CurrentMinStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_CurrentSet_allowed()
 *	Description: Execution allowed for CurrentSet attribute
 */
//--------------------------------------------------------
bool A2720::is_CurrentSet_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::CurrentSetStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::CurrentSetStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_DCCurrentCoefficient0_allowed()
 *	Description: Execution allowed for DCCurrentCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_DCCurrentCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::DCCurrentCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::DCCurrentCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::DCCurrentCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::DCCurrentCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_DCCurrentCoefficient1_allowed()
 *	Description: Execution allowed for DCCurrentCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_DCCurrentCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::DCCurrentCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::DCCurrentCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::DCCurrentCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::DCCurrentCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_DCLinkVoltage_allowed()
 *	Description: Execution allowed for DCLinkVoltage attribute
 */
//--------------------------------------------------------
bool A2720::is_DCLinkVoltage_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::DCLinkVoltageStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::DCLinkVoltageStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_DCurr_allowed()
 *	Description: Execution allowed for DCurr attribute
 */
//--------------------------------------------------------
bool A2720::is_DCurr_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::DCurrStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::DCurrStateAllowed_WRITE
			return false;
		}
		return true;
	}

	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_HeatsinkTempCoefficient0_allowed()
 *	Description: Execution allowed for HeatsinkTempCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_HeatsinkTempCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::HeatsinkTempCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::HeatsinkTempCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::HeatsinkTempCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::HeatsinkTempCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_HeatsinkTempCoefficient1_allowed()
 *	Description: Execution allowed for HeatsinkTempCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_HeatsinkTempCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::HeatsinkTempCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::HeatsinkTempCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::HeatsinkTempCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::HeatsinkTempCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_HeatsinkTemperature_allowed()
 *	Description: Execution allowed for HeatsinkTemperature attribute
 */
//--------------------------------------------------------
bool A2720::is_HeatsinkTemperature_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::HeatsinkTemperatureStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::HeatsinkTemperatureStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_KDCoefficient_allowed()
 *	Description: Execution allowed for KDCoefficient attribute
 */
//--------------------------------------------------------
bool A2720::is_KDCoefficient_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KDCoefficientStateAllowed_WRITE) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	A2720::KDCoefficientStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KDCoefficientStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	A2720::KDCoefficientStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_KFFCoefficient_allowed()
 *	Description: Execution allowed for KFFCoefficient attribute
 */
//--------------------------------------------------------
bool A2720::is_KFFCoefficient_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KFFCoefficientStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KFFCoefficientStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KFFCoefficientStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KFFCoefficientStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_KICoefficient_allowed()
 *	Description: Execution allowed for KICoefficient attribute
 */
//--------------------------------------------------------
bool A2720::is_KICoefficient_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KICoefficientStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KICoefficientStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KICoefficientStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KICoefficientStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_KPCoefficient_allowed()
 *	Description: Execution allowed for KPCoefficient attribute
 */
//--------------------------------------------------------
bool A2720::is_KPCoefficient_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KPCoefficientStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KPCoefficientStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::KPCoefficientStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::KPCoefficientStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Model_allowed()
 *	Description: Execution allowed for Model attribute
 */
//--------------------------------------------------------
bool A2720::is_Model_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::ModelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ModelStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_PulseDuration_allowed()
 *	Description: Execution allowed for PulseDuration attribute
 */
//--------------------------------------------------------
bool A2720::is_PulseDuration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::PulseDurationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::PulseDurationStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::PulseDurationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::PulseDurationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_SerialNumber_allowed()
 *	Description: Execution allowed for SerialNumber attribute
 */
//--------------------------------------------------------
bool A2720::is_SerialNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::SerialNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::SerialNumberStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_SlewRate_allowed()
 *	Description: Execution allowed for SlewRate attribute
 */
//--------------------------------------------------------
bool A2720::is_SlewRate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::SlewRateStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::SlewRateStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::SlewRateStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::SlewRateStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Voltage_allowed()
 *	Description: Execution allowed for Voltage attribute
 */
//--------------------------------------------------------
bool A2720::is_Voltage_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::ALARM)
		{
		/*----- PROTECTED REGION ID(A2720::VoltageStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::VoltageStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_VoltageCoefficient0_allowed()
 *	Description: Execution allowed for VoltageCoefficient0 attribute
 */
//--------------------------------------------------------
bool A2720::is_VoltageCoefficient0_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::VoltageCoefficient0StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::VoltageCoefficient0StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::VoltageCoefficient0StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::VoltageCoefficient0StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_VoltageCoefficient1_allowed()
 *	Description: Execution allowed for VoltageCoefficient1 attribute
 */
//--------------------------------------------------------
bool A2720::is_VoltageCoefficient1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(A2720::VoltageCoefficient1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::VoltageCoefficient1StateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::VoltageCoefficient1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::VoltageCoefficient1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_PsStat_allowed()
 *	Description: Execution allowed for PsStat attribute
 */
//--------------------------------------------------------
bool A2720::is_PsStat_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(A2720::PsStatStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	A2720::PsStatStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Abort_allowed()
 *	Description: Execution allowed for Abort attribute
 */
//--------------------------------------------------------
bool A2720::is_Abort_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::OFF ||
		get_state()==Tango::FAULT ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(A2720::AbortStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::AbortStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Off_allowed()
 *	Description: Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool A2720::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(A2720::OffStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::OffStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_On_allowed()
 *	Description: Execution allowed for On attribute
 */
//--------------------------------------------------------
bool A2720::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(A2720::OnStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::OnStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool A2720::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::OFF ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(A2720::ResetStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::ResetStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : A2720::is_StartCycling_allowed()
 *	Description: Execution allowed for StartCycling attribute
 */
//--------------------------------------------------------
bool A2720::is_StartCycling_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(A2720::StartCyclingStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	A2720::StartCyclingStateAllowed
		return false;
	}
	return true;
}


/*----- PROTECTED REGION ID(A2720::A2720StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	A2720::A2720StateAllowed.AdditionalMethods

}	//	End of namespace
